/*
 * EMU][ Apple ][-class emulator
 * Copyright (C) 2002, 2003 by the EMU][ Project/Dapple ][ Team
 *
 * $Header: /winc/emuiil/source/dapple.c,v 1.5 2003/08/30 10:22:29 dosius Exp $
 *
 * Component:  DAPPLE: main menu, global functions, keyboard emulation
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * $Log: dapple.c,v $
 * Revision 1.5  2003/08/30 10:22:29  dosius
 * Bugfixes; work on Z80 core
 *
 */

//#define EMUZ80

#include <dir.h>
/* Used by stringgeterror(): convert strerror format to one usable by the
     windowing system. -uso. */
#include <errno.h>
#include <dos.h>
#include <fcntl.h>		/* O_BINARY */
#include <go32.h>		/* _go32_want_ctrl_break() */
#include <signal.h>
#include <stdio.h>
#include <string.h>
#include <sys/exceptn.h>	/* __djgpp_set_ctrl_c() */
#include <unistd.h>
#include "dapple.h"
#include "asmlib.h"
#include "version.h"


/* video.c */
extern unsigned char virtcopy;
extern unsigned char virtvideobyte;
extern Charset virtcharset;
void virtinit();
void virtreset();
void virtsetmode();
void virtcacheinit();
void virtline(unsigned int rasterline);
void virtscreencopy();
void virtsethresmode(unsigned char mode);
unsigned char virtgethresmode();
void virtsetmonochrome(unsigned char mode);
unsigned char virtgetmonochrome();
void virtsetpalette(unsigned char mode);
unsigned char virtgetpalette();
void virtmenu();
unsigned int virtstore(unsigned int window, FILE *file, unsigned int percent);
unsigned int virtrestore(unsigned int window, FILE *file, unsigned int percent);

/* cpu65c02.c */
extern unsigned char stateflags;
extern unsigned char cpuwriteregsflag;
unsigned char cpuinuse();
void cpuinit();
void cpureset();
void cpuwriteregs(unsigned int window);
void cpusetlinecycle(unsigned int value);
unsigned int cpugetlinecycle();
void cpusetdelay(unsigned int value);
unsigned int cpugetdelay();
void cpusetstate(unsigned int value);
void cpuclearstate(unsigned int value);
unsigned char cpugetstate();
void cpuline();
void cpurun();
void cpumenu();
unsigned int cpustore(unsigned int window, FILE *file, unsigned int percent);
unsigned int cpurestore(unsigned int window, FILE *file, unsigned int percent);
unsigned char cpugettype();

#ifdef EMUZ80
void z80init();
void z80loadrom(unsigned int keyboard, unsigned int window);
//unsigned int z80store(unsigned int window, FILE *file);
//unsigned int z80restore(unsigned int window, FILE *file);
unsigned int z80new(slot *slotpointer, unsigned int slotnumber);
void z80setstate(unsigned int value);
void z80clearstate(unsigned int value);
unsigned char z80getstate();
void z80reset();
void z80line();
void z80writeregs(unsigned int window);
#endif

/* memory.c */
extern unsigned char memkey;
extern unsigned int  memjoyx;
extern unsigned int  memjoyy;
extern unsigned char memjoybutton0;
extern unsigned char memjoybutton1;
extern unsigned char memiic4080;
extern unsigned char memram[0x28000];
void soundinit();
void soundmenu();
void memoryinit();
void memoryclose();
void memoryreset();
unsigned int memoryautoloadrom(unsigned int keyboard, unsigned int window);
void memorymenu();
unsigned int memorystore(unsigned int window, FILE *file, unsigned int percent);
unsigned int memoryrestore(unsigned int window, FILE *file, unsigned int percent);

/* pic.c */
void parallelinit();
void parallelloadrom(unsigned int keyboard, unsigned int window);
//unsigned int parallelstore(unsigned int window, FILE *file);
//unsigned int parallelrestore(unsigned int window, FILE *file);
//void parallelmenu();
unsigned int parallelnew(slot *slotpointer, unsigned int slotnumber);

/* mouse.c */
void mouseinit();
//void mousereset();
void mouseloadrom(unsigned int keyboard, unsigned int window);
//unsigned int mousestore(unsigned int window, FILE *file);
//unsigned int mouserestore(unsigned int window, FILE *file);
//void mousemenu();
unsigned int mousenew(slot *slotpointer, unsigned int slotnumber);

/* lldisk.c */
void lldiskinit();
void lldiskloadrom(unsigned int keyboard, unsigned int window);
unsigned int lldisknew(slot *slotpointer, unsigned int slotnumber);
//void lldiskmenu();

/* disk.c */
/* drivedisk is defined in dapple.h -uso. */
extern drivedisk drivedisk1;
extern drivedisk drivedisk2;
extern unsigned char drivefastmode;
void driveinit();
//void drivereset();
void driveloadrom(unsigned int keyboard, unsigned int window);
unsigned int driveeject(drivedisk *disk);
unsigned int driveload(drivedisk *disk, unsigned char *filename);
//void drivemenu();
//unsigned int drivestore(unsigned int window, FILE *file);
//unsigned int driverestore(unsigned int window, FILE *file);
unsigned int drivenew(slot *slotpointer, unsigned int slotnumber);

/* ini.c */
void readini();
void writeini();


static const unsigned int KEYJOYLEFT	= 0x008;
static const unsigned int KEYJOYCENTER	= 0x600;	/* 0x575 */
static const unsigned int KEYJOYRIGHT	= 0xb7c;
void mainmenu();
void keyboardmenu();
unsigned int  keyboardstore(unsigned int window, FILE *file, unsigned int percent);
unsigned int  keyboardrestore(unsigned int window, FILE *file, unsigned int percent);
unsigned int  keyboard;		/* keyboard handle		*/
unsigned int  window;		/* window handle		*/
unsigned char appletype;	/* II+/IIe/IIc			*/
unsigned char key;
unsigned char keyspec;
unsigned char keycapslock;	/* capslock mode on? */
unsigned char keygerman;	/* switch 'Y' and 'Z' on German keyboards? */
unsigned char keybs;		/* switch <BS> and <DEL> ? */
unsigned char keyjoystick;	/* emulate joystick via numbpad or real joystick */
unsigned int  messagecount;
unsigned char messageflag;
unsigned char inimenulanguage;
unsigned char cpuflag;
unsigned int  inicpudelay;
unsigned char inirompath[260];
unsigned char inidiskpath1[260];
unsigned char inidiskpath2[260];
unsigned char inistatepath[260];
unsigned char inidebugflag;	/* debugger on? */
unsigned char inidrivemessageflag; /* display current drive track? */
unsigned char inidrivefastflag;
unsigned char callingpath[260];
unsigned char stringerror[256];	/* Is that enough? What is the maximum? */
slot	      slots[8];


/*--------------------------------------*/
/* General functions			*/
/*--------------------------------------*/

      unsigned int fileload(unsigned char *filename, unsigned int numbbytes,
			    unsigned int  *bytesread, void *memoryptr) {
	FILE *file;

	file=fopen(filename,"rb");
	if (!file) {
	  asmseterror(
"!\
:F;\
GDatei konnte nicht geffnet werden;\r\
EFile could not be opened;\r\
;");

	  *bytesread = 0;
	  return 1;	/* error */
	}
	*bytesread = fread(memoryptr, 1, numbbytes, file);	/* read data */
	fclose(file);
	return 0;

      } /* fileload */


      unsigned int filesave(unsigned char *filename, unsigned int numbbytes,
			    unsigned int  *byteswritten, void *memoryptr) {
	FILE *file;

	file=fopen(filename,"wb");
	if (!file) {
	  asmseterror(
"!\
:F;\
GDatei konnte nicht geffnet werden;\r\
EFile could not be opened;\r\
;");

	  *byteswritten = 0;
	  return 1;	/* error */
	}
	*byteswritten = fwrite(memoryptr, 1, numbbytes, file);	/* read data */
	fclose(file);
	return 0;

      } /* fileload */


      unsigned char keyboardyesno(unsigned int keyboard) {
	register unsigned char key;

	do {
	  do {
	    imageupdate();
	    key = (unsigned char)channelin(keyboard);
	  }
	  while ((key == 0) && (!exitprogram));
	  if ((key == 27) || (key == 32)) {
	    return 0;
	  }
	  if (inimenulanguage == 'E') {
	    switch (key) {
	      case 'n' :
	      case 'N' :
	        return 0;
	      case 'y' :
	      case 'Y' :
	        return 1;
	    }
	  }
	  else {
	    switch (key) {
	      case 'n' :
	      case 'N' :
	        return 0;
	      case 'j' :
	      case 'J' :
	        return 1;
	    }
	  }
	}
	while (!exitprogram);
	return 0;

      } /* keyboardyesno */


      unsigned char *stringgeterror() {
	register unsigned char *stringptr;

	stringptr = strerror(errno);
	strcpy(stringerror, stringptr);	/* copy string. GCC says: pointer to static string. Do no not modify. */

	stringptr = strchr(stringerror,'\n');
	while (stringptr) {		/* change C's newline to a CR for the windowing system */
	  *stringptr='\r';
	  stringptr=strchr(stringptr,'\n');
	}

	return stringerror;

      } /* stringgeterror */



      void stringwritecenterx(unsigned int window, unsigned char *stringpointer) {

	imagesetcursor(window, (WINDOWXSIZE - (strlen(stringpointer) << 3)) / 2, imagegetcursory(window) );
	stringwrite(window, stringpointer);

      } /* stringwritecenterx */


      void stringwriteyesno(unsigned int window, unsigned char value) {
	if (value) {
	  stringwritemessage(window,
"!\
EYes;\
GJa;\
");
	}
	else {
	  stringwritemessage(window,
"!\
ENo;\
GNein;\
");
	}

      } /* stringwriteyesno */


      void stringwriteonoff(unsigned int window, unsigned char value) {
	if (value) {
	  stringwritemessage(window,
"!\
EOn;\
GAn;\
");
	}
	else {
	  stringwritemessage(window,
"!\
EOff;\
GAus;\
");
	}

      } /* stringwriteonoff */


/*--------------------------------------*/


      unsigned int slotnofunction(void *slotdata) {

	return 0;

      } /* slotnofunction */


/*--------------------------------------*/


      unsigned int slotnostore(void *slotdata, unsigned int window, FILE *file, unsigned int percent) {

	return 0;

      } /* slotnostore */


/*--------------------------------------*/


      unsigned int slotnorestore(void *slotdata, unsigned int window, FILE *file, unsigned int percent) {

	return 0;

      } /* slotnostore */


/*--------------------------------------*/


      unsigned char slotnoget(void *slotdata, unsigned int address) {

	return virtvideobyte;

      } /* slotnoget */


/*--------------------------------------*/


      void slotnoset(void *slotdata, unsigned int address, unsigned int value) {

      } /* slotnoset */


/*--------------------------------------*/


      unsigned char slotnoromget(void *slotdata, unsigned int address) {

	return 0xff;

      } /* slotnoromget */


/*--------------------------------------*/


      void slotnoromset(void *slotdata, unsigned int address, unsigned int value) {

      } /* slotnoromset */


/*--------------------------------------*/


      void slotempty(slot *slotpointer) {

	slotpointer->slotclose		= (void *)&slotnofunction;
	slotpointer->slotreset		= (void *)&slotnofunction;
	slotpointer->slotstore		= (void *)&slotnostore;
	slotpointer->slotrestore	= (void *)&slotnorestore;
	slotpointer->slotget		= (void *)&slotnoget;
	slotpointer->slotset		= (void *)&slotnoset;
	slotpointer->slotromget		= (void *)&slotnoromget;
	slotpointer->slotromset		= (void *)&slotnoromset;
	slotpointer->slotmenu		= (void *)&slotnofunction;
	slotpointer->slotshift		= (void *)&slotnofunction;
	slotpointer->slotctrl		= (void *)&slotnofunction;
	slotpointer->slotshiftctrl	= (void *)&slotnofunction;
	slotpointer->slottype		= SLOTTYPENONE;
	slotpointer->slotdata		= NULL;
	slotpointer->slotname		= NULL;

      } /* slotempty */


/*--------------------------------------*/


      unsigned int windowprotocol(unsigned int *keyboard, unsigned int *window, unsigned char *title) {
        const unsigned int XSIZE = 480;
        const unsigned int YSIZE = 128;
	register unsigned int error;

	error = windowaddio(-1, -1, XSIZE, YSIZE, 0, 0, NULL, 0, keyboard, window);
	if (!error) {
	  imagedrawbox(*window, 0,	0,	XSIZE-1,YSIZE-1,0x000000);
	  imagefillbox(*window, 1,	YSIZE-2,XSIZE-2,YSIZE-2,0x404040);
	  imagefillbox(*window, XSIZE-2,1,	XSIZE-2,YSIZE-2,0x404040);
	  imagefillbox(*window, 1,	1,	XSIZE-2,1,	0xffffff);
	  imagefillbox(*window, 1,	1,	1,	YSIZE-2,0xffffff);
	  imagesetview(*window, 2,	2,	XSIZE-3,YSIZE-3);
	  imagesettextcolor(*window,	0x808080,	0xffffff);
	  imagesettextattribute(*window, IMAGEBOLD);
	  channelout(*window, 12);
	  stringwritemessage(*window, title);
	  imagesettextattribute(*window, 0);
	  imagefillbox(*window, 2, imagegetcursory(*window)+2, XSIZE-3, imagegetcursory(*window)+2, 0x404040);
	  imagefillbox(*window, 2, imagegetcursory(*window)+3, XSIZE-3, imagegetcursory(*window)+3, 0xffffff);
	  imagesetview(*window, 2,	imagegetcursory(*window)+6, XSIZE-3, YSIZE-3);

	  imagefillbox(*window,         14,    22, XSIZE - 14,    22, RGBWHITE);
	  imagefillbox(*window,         14,    22,         14, 24+65, RGBWHITE);
	  imagefillbox(*window, XSIZE - 14,    23, XSIZE - 14, 24+65, RGBDGREY);
	  imagefillbox(*window,         14, 24+65, XSIZE - 15, 24+65, RGBDGREY);
	  imagesetview(*window, 16, 24, XSIZE - 16, 24+63);
	  imagesettextcolor(*window,	0x808090,	0xffff00);
	  channelout(*window, 12);
	}
	return error;

      } /* windowprotocol */


/*--------------------------------------*/


      void windowpercent(unsigned int window, unsigned int value, unsigned char *message) {
        const unsigned int XLEFT  = 16;
        const unsigned int XRIGHT = 480 - 16;
        const unsigned int YTOP   = 128 - 25;
        const unsigned int YDOWN  = 128 - 15;

	imagesetview(window, 0, 0, 479, 127);
	if (value > 99) {
	  value = 99;
	}
	imagefillbox(window, XLEFT  - 1, YTOP  - 1, XRIGHT + 1, YTOP  - 1, RGBDGREY);
	imagefillbox(window, XLEFT  - 1, YTOP  - 1, XLEFT  - 1, YDOWN + 1, RGBDGREY);
	imagefillbox(window, XRIGHT + 1, YTOP  - 1, XRIGHT + 1, YDOWN + 1, RGBLGREY);
	imagefillbox(window, XLEFT     , YDOWN + 1, XRIGHT + 1, YDOWN + 1, RGBLGREY);
	imagefillbox(window, XLEFT     , YTOP     , XRIGHT    , YDOWN    , 0x405060);
	imagefillbox(window, XLEFT  + 1, YTOP  + 1, XLEFT + (unsigned int)(((XRIGHT - XLEFT) * value) / 100),
								YDOWN - 1, 0x7080a0);

	imagesetview(window, XLEFT, 24, XRIGHT, 24+63);
//	imagefillbox(window, XLEFT, 24, XRIGHT, 24+63, 0x808080);
//	imagesetcursor(window, XLEFT, 24+7);
	stringwritemessage(window, message);
	channelout(window, 13);

	imageupdate();

      } /* windowpercent */

/*--------------------------------------*/


      void windowpresskey(unsigned int keyboard, unsigned int window) {

	stringwritemessage(window,
"!\
EPress a key to continue.;\
GBitte drcken Sie eine beliebige Taste zum Fortfahren.;\
");
	do {
	  imageupdate();
	}
	while (((unsigned char)channelin(keyboard) == 0) && (!exitprogram));

      } /* windowpresskey */


/*--------------------------------------*/


      void imagetickbox(unsigned int window, unsigned int value) {

	register unsigned int cursorx;
	register unsigned int cursory;

	cursorx = imagegetcursorx(window);
	cursory = imagegetcursory(window);

	imagefillbox(window, cursorx, cursory-7, cursorx+7, cursory, RGBLIGHT);
	imagefillbox(window, cursorx, cursory-6, cursorx+6, cursory, RGBDARK);
	imagefillbox(window, cursorx+1, cursory-6, cursorx+6, cursory-1, RGBWHITE);

	if (value) {
	  imageline(window, cursorx+2, cursory-4, cursorx+3, cursory-2, RGBBLACK);
	  imageline(window, cursorx+3, cursory-2, cursorx+6, cursory-5, RGBBLACK);
	}
	imagesetcursor(window, cursorx+8, cursory);

      } /* stringwritecenterx */


/*-------------------------------------*/


     void setmessage(unsigned char *message) {

	if (messageflag) {
	  imagesetcursor(window, 0, 399);
	  imagefillbox(window, 0, 392, 639, 399, 0xff8000);
	  imagesettextcolor(window, 0xff8000, 0x000000);
	  stringwritemessage(window, message);
	  messagecount = 50 * 4;
	  virtcopy = 1;
	}

     } /* setmessage */


/*-------------------------------------*/


      void applereset() {

	cpuflag = 0;
	imagefillbox(window, 0, 0, 639, 7, RGBBLACK);
	cpureset();
	memoryreset();
	virtreset();
	slots[1].slotreset(slots[1].slotdata);
	slots[2].slotreset(slots[2].slotdata);
	slots[3].slotreset(slots[3].slotdata);
	slots[4].slotreset(slots[4].slotdata);
	slots[5].slotreset(slots[5].slotdata);
	slots[6].slotreset(slots[6].slotdata);
	slots[7].slotreset(slots[7].slotdata);

	setmessage("Reset Apple");

      } /* applereset */


/*-------------------------------------*/


      unsigned int applestore(unsigned char *filename) {
	unsigned int  keyboard;
	unsigned int  window;
	unsigned int  slot;
	unsigned char header[24];
	unsigned char oldcwd[260];
	FILE *file;
	register unsigned int error;


	error = windowprotocol(&keyboard, &window,
"!\
ESave emulation state;\
GSpeichere Emulationszustand;\
");
	if (!error) {

	  getcwd(oldcwd, 256);
	  chdir(callingpath);

	  file = fopen(filename, "wb");
	  if (!(file)) {
	    stringwrite(window, "Sorry, I could not open the file \"");
	    stringwrite(window, filename);
	    stringwrite(window, "\".\r");
	    error = 1;
 	  }
	  else {

	    strcpy(header, "EMU][ STATE V0.31");
	    fwrite(header,	sizeof(header),	1, file);
	    windowpercent(window, 8,
"!\
EHeader stored.;\
GHeader gespeichert.;\
");
	    error = keyboardstore(window, file, 16);
	    if (!error) {
	      error = memorystore(window, file, 24);
	      if (!error) {
		error = cpustore(window, file, 32);
		if (!error) {
		  fwrite(&cpuflag, sizeof(cpuflag), 1, file);
		  error = virtstore(window, file, 40);
		  if (!error) {
		    slot = 1;
		    do {
		      fwrite(&slots[slot].slottype,	sizeof(slots[slot].slottype),	1, file);
		      error = slots[slot].slotstore(slots[1].slotdata, window, file, 40 + slot*8);
		      slot++;
		    }
		    while ((!error) && (slot < 8));
		    if (!error) {
		      windowpercent(window, 100,
"!\
EEmulator state stored.;\
GEmulatorzustand gespeichert.;\
");
//		      windowpresskey(keyboard, window);
		    }
		  }
		}
	      }
	    }

	    fclose(file);
	  }

	  chdir(oldcwd);

	  if (error) {
	    windowpresskey(keyboard, window);
	  }

	  channelclose(keyboard);
	  channelclose(window);
	}

	return error;

      } /* applestore */


/*-------------------------------------*/


      unsigned int applerestore(unsigned char *filename) {
	unsigned int  keyboard;
	unsigned int  window;
	unsigned int  slot;
	unsigned char header[24];
	unsigned char oldcwd[260];
	FILE *file;
	register unsigned int error;


	error = windowprotocol(&keyboard, &window,
"!\
ELoad emulation state;\
GLade Emulatorzustand;\
");
	if (!error) {

	  windowpercent(window, 0,
"!\
ERestoring emulator state...\r;\
GWiederherstellen des Emulatorzustands...\r;\
");

	  getcwd(oldcwd, 256);
	  chdir(callingpath);

	  file = fopen(filename, "rb");
	  if (!(file)) {
	    stringwrite(window, "Sorry, I could not open the file \"");
	    stringwrite(window, filename);
	    stringwrite(window, "\".\r");
	    error = 1;
 	  }
	  else {

	    fread(header, sizeof(header), 1, file);
	    if (strcmp(header, "EMU][ STATE V0.31")) {
	      stringwrite(window, "File is not an Emu ][ Emulator State file.\r");
	      error = 1;
	    }
	    else {
	      windowpercent(window, 8,
"!\
EHeader found;\
GHeader gefunden;\
");
	      error = keyboardrestore(window, file, 16);
	      if (!error) {
		error = memoryrestore(window, file, 24);
		if (!error) {
		  error = cpurestore(window, file, 32);
		  if (!error) {
		    fread(&cpuflag, sizeof(cpuflag), 1, file);
		    error = virtrestore(window, file, 40);
		    if (!error) {
		      slot = 1;
		      do {
			slots[slot].slotclose(slots[slot].slotdata);	/* close old slot */
			slotempty(&slots[slot]);			/* define empty slot */
			fread(&slots[slot].slottype,	sizeof(slots[slot].slottype),	1, file);
			switch (slots[slot].slottype) {
			  case SLOTTYPENONE :
			    break;
			  case SLOTTYPEPARALLEL :
			    parallelnew(&slots[slot], slot);
			    break;
			  case SLOTTYPEMOUSE :
			    mousenew(&slots[slot], slot);
			    break;
#ifdef EMUZ80
			  case SLOTTYPEZ80 :
			    z80new(&slots[slot], slot);
			    break;
#endif
			  case SLOTTYPEMASSSTORE :
			    lldisknew(&slots[slot], slot);
			    break;
			  case SLOTTYPEDISKDRIVE :
			    drivenew(&slots[slot], slot);
			    break;
			} /* switch */
			error = slots[slot].slotrestore(slots[slot].slotdata, window, file, 40 + slot*8);
			if (error) {
			  slotempty(&slots[slot]);
			}
			slot++;
		      }
		      while ((!error) && (slot < 8));
		      if (!error) {
			windowpercent(window, 100,
"!\
EEmulator state restored.\r;\
GEmulatorzustand wiederhergestellt.\r;\
");
	  	      }
	  	    }
	  	  }
	  	}
	      }
	    }

	    fclose(file);
	  }

	  chdir(oldcwd);

	  if (error) {
	    windowpresskey(keyboard, window);
	  }

	  channelclose(keyboard);
	  channelclose(window);
	}

	return error;

      } /* applerestore */


/*-------------------------------------*/


      void quitmenu() {
	unsigned int quitscreen;
	unsigned int quitkeyboard;
	unsigned int quitwindow;
	register unsigned int x;
	register unsigned int y;

	quitscreen = screenstore();

	if (inicpudelay < 0x100) {
	  for (y = 0; y <= 399; ) {
	    for (x = 0; x <= 639; x = x + 2) {
	      imageplot(window, x, y, 0);
	    }
	    y++;
	    for (x = 1; x <= 639; x = x + 2) {
	      imageplot(window, x, y, 0);
	    }
	    y++;
	  }
	}
	else {
	  for (y = 0; y <= 399; y++) {
	    for (x = 0; x <= 639; x++ ) {
	      imageplot(window, x, y, (imagegetpixel(window, x, y) & 0xfefefe) >> 1);	/* Halftone */
	    }
	  }
	}

	if (windowaddio( -1, -1, 400, 64, -1, 1,
"!\
EQuit Emulator;\
GVerlasse Emulator;\
", 0, &quitkeyboard, &quitwindow)) {
	  screenrestore(quitscreen);
	  exitprogram = 1;
	  return;
	}
	stringwritemessage(quitwindow,
"!\
E\r\r  Quit emulator: Are you sure? (y/n);\
G\r\r  Verlasse den Emulator: Sind Sie sicher? (j/n);\
");
	if (keyboardyesno(quitkeyboard)) {
	  exitprogram = 1;
	}
	channelclose(quitkeyboard);
	channelclose(quitwindow);
	screenrestore(quitscreen);
	if (exitprogram) {
	  if (inicpudelay < 0x100) {
	    for (y = 0; y <= 399; ) {
	      for (x = 0; x <= 639; x = x + 2) {
	        imageplot(window, x, y, 0);
	      }
	      y++;
	      for (x = 1; x <= 639; x = x + 2) {
	        imageplot(window, x, y, 0);
	      }
	      y++;
	    }
	  }
	  else {
	    for (y = 0; y <= 399; y++) {
	      for (x = 0; x <= 639; x++ ) {
	        imageplot(window, x, y, (imagegetpixel(window, x, y) & 0xfefefe) >> 1);	/* Halftone */
	      }
	    }
	  }
	}

      } /* quitmenu */


/*--------------------------------------*/


      unsigned int keyboardstore(unsigned int winprotocol, FILE *file, unsigned int percent) {
	unsigned char header[32];

	memset(header, 0x00, sizeof(header));
	strcpy(header, "KEYBOARD STATE V0.25");
	fwrite(header,		sizeof(header),	1, file);

	fwrite(&keygerman,	sizeof(keygerman),	1, file);
	fwrite(&keycapslock,	sizeof(keycapslock),	1, file);
	fwrite(&keyjoystick,	sizeof(keyjoystick),	1, file);

	windowpercent(winprotocol, percent,
"!\
EKeyboard stored.;\
GTastatur gespeichert.;\
");
	return 0;

      } /* keyboardstore */


/*--------------------------------------*/


      unsigned int keyboardrestore(unsigned int winprotocol, FILE *file, unsigned int percent) {
        unsigned char header[32];

	fread(header,		sizeof(header),		1,file);
	if (strcmp(header, "KEYBOARD STATE V0.25")) {
	  stringwrite(winprotocol, "Keyboard emulation data not found.\r");
	  return 1;
	}

	fread(&keygerman,	sizeof(keygerman),	1, file);
	fread(&keycapslock,	sizeof(keycapslock),	1, file);
	fread(&keyjoystick,	sizeof(keyjoystick),	1, file);

	windowpercent(winprotocol, percent,
"!\
EKeyboard restored.\
GTastatur geladen.\
");

	return 0;

      } /* keyboardrestore */


/*--------------------------------------*/


static int joya(void) {
  union REGS regs;

  regs.h.ah=0x84;
  regs.x.dx=0;
  int86(0x15,&regs,&regs); /* al */
  if ((regs.h.al&0x10)==0) return 255; else return 0;
}

static int joyb(void) {
  union REGS regs;

  regs.h.ah=0x84;
  regs.x.dx=0;
  int86(0x15,&regs,&regs); /* al */
  if ((regs.h.al&0x20)==0) return 255; else return 0;
}


/*-------------------------------------*/


      void keyconvert() {
	register int i;

	memjoybutton0 = 0x00;
	memjoybutton1 = 0x00;

	if (keyjoystick) {		/* read PC joystick? */
	   memjoybutton0 = joya();
	   memjoybutton1 = joyb();
	}
	else {				/* joystick emulation via numeric keypad */
	  i = keyboardjoyx();
	  if (i < 0) { memjoyx = KEYJOYLEFT; }
	  else {
	    if (i == 0)	{ memjoyx = KEYJOYCENTER; }
	    else	{ memjoyx = KEYJOYRIGHT; }
	  }
	  i = keyboardjoyy();
	  if (i < 0) { memjoyy = KEYJOYLEFT; }
	  else {
	    if (i == 0)	{ memjoyy = KEYJOYCENTER; }
	    else	{ memjoyy = KEYJOYRIGHT; }
	  }
	}

	i = keyboardjoyb();	/* open and close apple button will always work, even on an Apple][+ */
	if (i & 0xff00)		{ memjoybutton0 = memjoybutton0 | 0x80; }
	if (i & 0xff)		{ memjoybutton1 = memjoybutton1 | 0x80; }

	i = channelin(keyboard) & 0xffff;
	key	= (unsigned char)i;
	keyspec	= (unsigned char)(i >> 8);

	switch (key) {
	  case 0 :		/* no key pressed */
	    break;
	  case 28 :		/* function keys */
	    switch (keyspec) {
	      case 0x90 :	/* <Arrow-Left> */
		memkey = 0x88;
		break;
	      case 0x91 :	/* <Arrow-Right> */
		memkey = 0x95;
		break;
	      case 0x92 :	/* <Arrow-Up> */
		memkey = 0x8b;
		break;
	      case 0x93 :	/* <Arrow-Down> */
		memkey = 0x8a;
		break;
	      case 0xc1 :	/* <F1> */
	        slots[1].slotmenu(slots[1].slotdata);
		imageupdate();
		break;
	      case 0xc2 :	/* <F2> */
	        slots[2].slotmenu(slots[2].slotdata);
		imageupdate();
		break;
	      case 0xc3 :	/* <F3> */
		virtmenu();
		imageupdate();
		break;
	      case 0xc4 :	/* <F4> */
		cpumenu();
		imageupdate();
		break;
	      case 0xc5 :	/* <F5> */
	        slots[5].slotmenu(slots[5].slotdata);
	        imageupdate();
	        break;
	      case 0xc6 :	/* <F6> */
	        slots[6].slotmenu(slots[6].slotdata);
	        imageupdate();
	        break;
	      case 0xc8 :	/* <F8> */
	        memorymenu();
	        if (appletype == 0) {
	          mainmenu();
	        }
	        imageupdate();
	        break;
		/* if (!nof8) prtsc(); */
		break;
	      case 0xc9 :	/* <F9> */
		keyboardmenu();
		imageupdate();
		break;
	      case 0xca :	/* <F10> */
	        mainmenu();
	        imageupdate();
		break;
	      case 0xcb :	/* <F11> */
                if (appletype == APPLEIIC) {
                    memiic4080 = !memiic4080;
                    setmessage(memiic4080?"Screen switch set to 80 columns":
                                          "Screen switch set to 40 columns");
                }
	        break;
	    } /* switch (keyspec) */
	    break;
	  case 29 :		/* shift function keys */
	    switch (keyspec) {
	      case 0xc1 :	/* <Shift-F1> */
	        slots[1].slotshift(slots[1].slotdata);
	        imageupdate();
	        break;
	      case 0xc2 :	/* <Shift-F2> */
	        slots[2].slotshift(slots[2].slotdata);
	        imageupdate();
	        break;
	      case 0xc3 :	/* <Shift-F3> */
		virtsetmonochrome((virtgetmonochrome() + 1) & 0x3);
		break;
	      case 0xc4 :	/* <Shift-F4> */
		if (memjoybutton0 || memjoybutton1) { exitprogram = -1; }
		else {
		  if (cpugetlinecycle() == 65) {
		    cpusetlinecycle(65 * 8);
		    cpusetdelay(0);
		    drivefastmode = 0;
		    setmessage(
"!\
ESet 65x02 CPU to fast mode;\
GSchalte 65x02 CPU in den Schnellmodus;\
");
		  }
		  else {
		    cpusetlinecycle(65);
		    cpusetdelay(inicpudelay);
		    drivefastmode = 0;
		    setmessage(
"!\
ESet 65x02 CPU to 1Mhz;\
GSchalte 65x02 CPU in 1Mhz Modus;\
");
		  }
		}
		break;
	      case 0xc5 :	/* <Shift-F5> */
	        slots[5].slotshift(slots[5].slotdata);
	        imageupdate();
	        break;
	      case 0xc6 :	/* <Shift-F6> */
	        slots[6].slotshift(slots[6].slotdata);
	        imageupdate();
	        break;
	      case 0xc8 :	/* <Shift-F8> */
		if (!(applestore(inistatepath))) {
		  setmessage(
"!\
EEmulation state stored;\
GEmulationszustand gespeichert;\
");
		}
		else {
		  virtcopy = 1;
		}
	        break;
	      case 0xc9 :	/* <Shift-F9> */
		quitmenu();
		imageupdate();
		break;
	    } /* switch (keyspec) */
	    break;
	  case 30 :		/* control function keys */
	    switch (keyspec) {
	      case 0xc1 :	/* <Ctrl-F1> */
	        slots[1].slotctrl(slots[1].slotdata);
	        imageupdate();
	        break;
	      case 0xc2 :	/* <Ctrl-F2> */
	        slots[2].slotctrl(slots[2].slotdata);
	        imageupdate();
	        break;
	      case 0xc3 :	/* <Ctrl-F3> */
		i = virtgetpalette();
		i++;
		if (i > 3) { i = 0; }
		virtsetpalette(i);
		break;
	      case 0xc4 :	/* <Ctrl-F4> */
		if (memjoybutton0 || memjoybutton1) { exitprogram = -1; }
		else {
#ifdef EMUZ80
		  if (!cpuflag) {
#endif
		    if (cpugetstate() & STATEHALT) {
		      cpuclearstate(STATEHALT);
		    }
		    else {
		      cpusetstate(STATEHALT);
		    }
#ifdef EMUZ80
		  }
		  else {
		    if (z80getstate() & STATEHALT) {
		      z80clearstate(STATEHALT);
		    }
		    else {
		      z80setstate(STATEHALT);
		    }
		  }
#endif
		}
		break;
	      case 0xc5 :	/* <Ctrl-F5> */
	        slots[5].slotctrl(slots[5].slotdata);
	        imageupdate();
	        break;
	      case 0xc6 :	/* <Ctrl-F6> */
	        slots[6].slotctrl(slots[6].slotdata);
	        imageupdate();
	        break;
	      case 0xc8 :	/* <Ctrl-F8> */
		if (!(applerestore(inistatepath))) {
		  setmessage(
"!\
EEmulation state restored;\
GEmulationszustand wiederhergestellt;\
");
		}
		else {
		  virtcopy = 1;
		}
		break;
	      case 0xc9 :	/* <Ctrl-F9> */
		inidebugflag = 1;
		ramdebugger(memram, sizeof(memram));
		inidebugflag = 0;
		virtsetmode();
		virtcacheinit();
		break;
	      case 0xca :	/* <Ctrl-F10> */
	      case 0xcc :	/* <Ctrl-F12> */
		applereset();
		break;
	    } /* switch (keyspec) */
	    break;
	  case 31 :		/* shift control function keys */
	    switch (keyspec) {
	      case 0xc1 :	/* <Shift-Ctrl-F1> */
	        slots[1].slotshiftctrl(slots[1].slotdata);
	        imageupdate();
	        break;
	      case 0xc2 :	/* <Shift-Ctrl-F2> */
		slots[2].slotshiftctrl(slots[2].slotdata);
		imageupdate();
		break;
	      case 0xc3 :	/* <Shift-Ctrl-F3> */
		i = virtgethresmode();
		if (i >= 2) {
		  i = 0;
		}
		else {
		  i++;
		}
		virtsethresmode(i);
		break;
	      case 0xc5 :	/* <Shift-Ctrl-F5> */
		slots[5].slotshiftctrl(slots[5].slotdata);
		imageupdate();
		break;
	      case 0xc6 :	/* <Shift-Ctrl-F6> */
		slots[6].slotshiftctrl(slots[6].slotdata);
		imageupdate();
		break;
	    } /* switch (keyspec) */
	    break;
	  default :
	    if (key <= 0x7f) {

	      if (keybs) {
		if (key == 0x8) {
		  if (!(keyboardmap[0x82]) || (keyboardmap[0x83])) {	/* not CTRL-H ! */
		    key = 0x7f;		/* change to <DEL> */
		  }
		}
		else {
		  if (key == 0x7f) {
		    key = 0x08;		/* change to <BS> */
		  }
		}
	      } /* if (keybs) */

	      if (keycapslock) {
		if ( ((key >= 'A') && (key <= 'Z')) || ((key >= 'a') && (key <= 'z')) ) {
		  key = key ^ 0x20;
		}
	      } /* if (keycapslock) */

	      if (keygerman) {
		if (key == 'Y') { key = 'Z'; }
		else {
		  if (key == 'y') { key = 'z'; }
		  else {
		    if (key == 'Z') { key = 'Y'; }
		    else {
		      if (key == 'z') { key = 'y'; }
		    }
		  }
		}
	      } /* if (keygerman) */

	      memkey = key | 0x80;
	    }
	    else { /* if (key <= 0x7f) */
	      switch (key) {
		case 196 : memkey = 0xdb; break;	/*  */
		case 214 : memkey = 0xdc; break;	/*  */
		case 220 : memkey = 0xdd; break;	/*  */
		case 228 : memkey = 0xfb; break;	/*  */
		case 246 : memkey = 0xfc; break;	/*  */
		case 252 : memkey = 0xfd; break;	/*  */
		case 223 : memkey = 0xfe; break;	/*  */
	      }
	    }
	} /* switch (key) */

      } /* keyconvert */


/*-------------------------------------*/


      void keyboardinit () {

	keycapslock = 1;
	keygerman   = 0;
	keybs       = 0;
	keyjoystick = 0;
	keyboardsetlayout(USA);

      } /* keyboardinit */


/*-------------------------------------*/


      void keyboardmenu () {
	unsigned int  menukeyboard;
	unsigned int  menuwindow;
	register unsigned char key;
	register unsigned char update;

	if (!windowaddio( -1, -1, WINDOWXSIZE, WINDOWYSIZE, -1, 1,
"!\
EKeyboard Options;\
GKeyboard Optionen;\
", 0, &menukeyboard, &menuwindow)) {
	  update = 1;
	  do {
	    if (update) {
	      
	      channelout(menuwindow, 12);		/* clear window */

	      stringwritemessage(menuwindow,
"!\
E\r[ESC] - Quit\r\r\
\r[C] - ;\
G\r[ESC] - Verlasse Men\r\r\
\r[C] - ;\
;");
//	      imagetickbox(window, keycapslock);
	      stringwritemessage(menuwindow,
"!\
EReverse Caps Lock: ;\
GInvertiere Caps Lock: ;\
;");
	      stringwriteyesno(menuwindow, keycapslock);

	      stringwritemessage(menuwindow,
"!\
E\r[S] - Switch keys 'Y' and 'Z': ;\
G\r[S] - Vertausche die Tasten 'Y' und 'Z': ;\
;");
	      stringwriteyesno(menuwindow, keygerman);

	      stringwritemessage(menuwindow,
"!\
E\r[B] - Switch <BS> and <DEL>: ;\
G\r[B] - Vertausche die Tasten <BS> und <DEL>: ;\
;");
	      stringwriteyesno(menuwindow, keybs);

	      stringwrite(menuwindow,"\r\r      ");
	      imagesettextattribute(menuwindow, IMAGEUNDERLINE);
	      stringwritemessage(menuwindow,
"!\
EKeyboard Layout:;\
GTastatur Layout:;\
;");
	      imagesettextattribute(menuwindow, 0);
	      imagesetcursor(menuwindow, imagegetcursorx(menuwindow), imagegetcursory(menuwindow)+2);

	      stringwritemessage(menuwindow,
"!\
E\r[U] - USA:     ;\
G\r[U] - USA:         ;\
;");
	      channelout(menuwindow, keyboardgetlayout()==0 ? '*':' ');
	      stringwritemessage(menuwindow,
"!\
E\r[G] - Germany: ;\
G\r[G] - Deutschland: ;\
;");
	      channelout(menuwindow, keyboardgetlayout()==1 ? '*':' ');

	      stringwrite(menuwindow,"\r\r      ");
	      imagesettextattribute(menuwindow, IMAGEUNDERLINE);
	      stringwritemessage(menuwindow,
"!\
EJoystick;\
GJoystick:\
;");
	      imagesettextattribute(menuwindow, 0);
	      imagesetcursor(menuwindow, imagegetcursorx(menuwindow), imagegetcursory(menuwindow)+2);


	      stringwritemessage(menuwindow,
"!\
E\r[J] - Joystick emulation: ;\
G\r[J] - Joystick Emulation: ;\
;");
	      if (keyjoystick) {
		stringwritemessage(menuwindow,
"!\
EPC joystick;\
GPC Joystick;\
;");
	      }
	      else {
		stringwritemessage(menuwindow,
"!\
ENumeric keypad;\
GZiffernblock;\
;");
	      }
	      update = 0;
	    }
	    do {
	      imageupdate();
	      key = (unsigned char)channelin(menukeyboard);
	    }
	    while ((key == 0) && (!exitprogram));
	    switch (key) {
	      case 'b' :
	      case 'B' :
		keybs = !keybs;
		update = 1;
		break;
	      case 'c' :
	      case 'C' :
		keycapslock = !keycapslock;
		update = 1;
		break;
	      case 'g' :
	      case 'G' :
		keyboardsetlayout(1);
		update = 1;
		break;
	      case 'j' :
	      case 'J' :
		keyjoystick = !keyjoystick;
		if (keyjoystick) {
		  memjoyx = KEYJOYCENTER;
		  memjoyy = KEYJOYCENTER;
		}
		update = 1;
		break;
	      case 's' :
	      case 'S' :
		keygerman = !keygerman;
		update = 1;
		break;
	      case 'u' :
	      case 'U' :
		keyboardsetlayout(0);
		update = 1;
		break;
	    } /* switch (key) */
	  }
	  while ((key != 27) && (key != 32) && (key != 13) && (!exitprogram));
	  channelclose(menukeyboard);
	  channelclose(menuwindow);
	}

      } /* keyboardmenu */


/*-------------------------------------*/


      int strright (char *tgt, char *src) {
	int x = strlen(src);

	return !stringcomparec(&(tgt[strlen(tgt)-x]), src);
      } /* strright */


      void cwdxchgslash(unsigned char *stringptr, unsigned int value) {

	getcwd(stringptr, value);
	while (*stringptr) {
	  if (*stringptr == '/') {
	    *stringptr = '\\';
	  }
	  stringptr++;
	} /* while */
      } /* cwdxchgslash */


      void getpathstring(unsigned char *destptr, unsigned char *sourceptr) {
	register unsigned char *last;
	register unsigned char c;

	last = destptr;
	do {
	  c = *(sourceptr++);
	  *destptr = c;
	  if (c == '\\') {
	    last = destptr;
	  }
	  destptr++;
	}
	while (c != '\0');
	*last = '\0';

      } /* getpathstring */


      void getfilestring(unsigned char *destptr, unsigned char *sourceptr) {
	register unsigned char *last;
	register unsigned char c;

	last = sourceptr;
	do {
	  c = *(sourceptr++);
	  if ((c == '\\') || (c == ':')) {
	    last = sourceptr;
	  }
	}
	while (c != '\0');
	do {
	  c = *(last++);
	  *(destptr++) = c;
	}
	while (c != '\0');
      } /* getfilestring */


/* maximum number of filenames for fdialog(), 256+16 bytes each */
#define MFN 512
#define MAXROWS 24

typedef struct {
  char name[260]	structpack;
  int  attr		structpack;
} fnam;


      void filesort(fnam *fnames, unsigned int *fnamesptr, int attribute,
      		    unsigned int min, unsigned int max) {

	register int i;
	register int j;
	unsigned int temp;

/* stupid bubblesort algorithm */
	for (i=min+1; i <= max; i++) {
	  for (j=max; j >= i; j--) {
	    if (fnames[fnamesptr[j-1]].attr == attribute) {
	      if (fnames[fnamesptr[j]].attr == attribute) {
		if (stringcomparec( fnames[fnamesptr[j-1]].name, fnames[fnamesptr[j]].name) > 0) {
		  temp = fnamesptr[j-1];
		  fnamesptr[j-1] = fnamesptr[j];
		  fnamesptr[j] = temp;
		}
	      }
	      else {
		temp = fnamesptr[j-1];
		fnamesptr[j-1] = fnamesptr[j];
		fnamesptr[j] = temp;
	      }
	    }
	  } /* for j */
	} /* for i */

      } /* filesort */


      unsigned int fileselectmenu (unsigned char *windowtitle, unsigned char *title,
				   unsigned char *filename, unsigned char *filepath, unsigned char *tail,
				   unsigned char optnew) {

	unsigned int  keyboard;
	unsigned int  window;
	unsigned char path[260];
	unsigned char oldpath[260];
	unsigned char filestring[260];
	unsigned int  fileminnumber;
	unsigned int  filenumber = 0;
	int cursor;
	int cursorx;
	int cursory;
	int columnstart = 0;
	int i;
	struct ffblk ffblk;

	fnam fnames[MFN];
	unsigned int fnamesptr[MFN];

	unsigned char key;
	unsigned char keyspec;
	unsigned char update;
	unsigned char reload;


	if (windowaddio( -1, -1, WINDOWXSIZE, WINDOWYSIZE, -1, 1, windowtitle, 0, &keyboard, &window)) {
	  exitprogram = 1;
	  return 0;
	}

	cwdxchgslash(oldpath, MAXPATH);			/* store old path */
	chdir(filepath);				/* change to new path */
	cursor = 0;
	update = 1;
	reload = 1;

	do {
	  if (reload) {		/* do we have to load the filename array? */
	    cwdxchgslash(path, MAXPATH);			/* get current directory */

	    filenumber = 0;					/* add fix elements to array */
	    fileminnumber = 0;
	    if (optnew) {
	      if (strlen(filename) != 0) {
		fnames[0].attr = -1;
		getfilestring(fnames[0].name, filename);
		fnamesptr[0] = 0;
		filenumber++;
		fileminnumber++;
	      }

	      if (inimenulanguage == 'G') {
		strcpy(fnames[filenumber].name,"(Neue Datei)");
	      }
	      else {
		strcpy(fnames[filenumber].name,"(New File)");
	      }
	      fnames[filenumber].attr = -2;
	      fnamesptr[filenumber] = filenumber;
	      filenumber++;
	      fileminnumber++;
	    }

	    if (inimenulanguage == 'G') {
	      strcpy(fnames[filenumber].name,"(Laufwerk auswhlen)");
	    }
	    else {
	      strcpy(fnames[filenumber].name,"(Select Drive)");
	    }
	    fnames[filenumber].attr = -3;
	    fnamesptr[filenumber] = filenumber;
	    filenumber++;
	    fileminnumber++;

	    i = findfirst("*.*", &ffblk, FA_DIREC);		/* put all filenames into array */
	    while ( (!i) && (filenumber < MFN) ) {
	      strcpy(fnames[filenumber].name, ffblk.ff_name);
	      fnames[filenumber].attr = (ffblk.ff_attrib & FA_DIREC) ? FA_DIREC : 0;	/* directory? */

	      if (!stringcomparec(tail,"._img_")) {		/* Custom mode for tail "._img_" */
		if ((fnames[filenumber].attr) || (strright(fnames[filenumber].name,".DSK"))
/*					      || (strright(fnames[filenumber].name,".IIE")) not yet */
/*					      || (strright(fnames[filenumber].name,".2MG")) not yet */
					      || (strright(fnames[filenumber].name,".DO"))
					      || (strright(fnames[filenumber].name,".PO"))
					      || (strright(fnames[filenumber].name,".NIB"))
					      || (strright(fnames[filenumber].name,".NB2"))) {
					        fnamesptr[filenumber] = filenumber;
					        filenumber++;
		}
	      }
	      else {
		if (!stringcomparec(tail,"._prg_")) {		/* Custom mode for tail "._prg_" */
		  if ((fnames[filenumber].attr)	|| (strright(fnames[filenumber].name,".PG2"))
						|| (strright(fnames[filenumber].name,".APL"))) {
						  fnamesptr[filenumber] = filenumber;
						  filenumber++;
		  }
		}
		else {
		  if (!stringcomparec(tail,"._s_")) {		/* Custom mode for tail "._s_" */
		    if ((fnames[filenumber].attr)	|| (strright(fnames[filenumber].name,".S"))
							|| (strright(fnames[filenumber].name,".ASM"))
							|| (strright(fnames[filenumber].name,".A65"))
							|| (strright(fnames[filenumber].name,".TXT"))) {
							  fnamesptr[filenumber] = filenumber;
							  filenumber++;
		    }
		  }
		  else {
		    if (!stringcomparec(tail,".*")) {
		      fnamesptr[filenumber] = filenumber;
		      filenumber++;
		    }
		    else {
		      if ((fnames[filenumber].attr) || (strright(fnames[filenumber].name, tail))) {
			fnamesptr[filenumber] = filenumber;
			filenumber++;
		      }
		    }
		  }
		}
	      }
	      i = findnext(&ffblk);
	    } /* while */

	    filesort(fnames, fnamesptr, FA_DIREC, fileminnumber, filenumber-1);
	    filesort(fnames, fnamesptr, 0, fileminnumber, filenumber-1);

	    cursor	= 0;			/* set to first entry in array */
	    columnstart	= 0;
	    reload	= 0;
	  }

	  if (update) {
	    channelout(window, 12);		/* clear window */

	    if (strlen(path) > ((WINDOWXSIZE/8)-4)) {		/* print current directory path */
	      path[(WINDOWXSIZE/8)-4] = 0;
	      imagesetcursor(window, 8, 22);
	    }
	    else {
	      imagesetcursor(window, (WINDOWXSIZE - (strlen(path) << 3)) >> 1, 22);
	    }
	    stringwrite(window, path);

	    imagefillbox(window, 0, 24, WINDOWXSIZE, 25, 0xffff00);
	    imagefillbox(window, 0, WINDOWYSIZE - 34, WINDOWXSIZE, WINDOWYSIZE - 35, 0xffff00);
	    imagefillbox(window, 0, WINDOWYSIZE - 23, WINDOWXSIZE, WINDOWYSIZE - 24, 0xffff00);

	    imagesetcursor(window, 12, WINDOWYSIZE-25);
	    stringwritemessage(window, title);
	    imagesetcursor(window, 4, WINDOWYSIZE-13);			/* print bottom message */

	    stringwritemessage(window,
"!\
E Arrows move, <ENTER> selects, <ESC> exits\r Folder names end in \"\\\". ;\
G Pfeiltasten bewegen Cursor, <ENTER> zur Auswahl,\r <ESC> Abbruch, Verzeichnisnamen enden in \"\\\". ;\
;");

	    i = columnstart;
	    cursorx = 8;
	    cursory = 35;
	    while ((i < filenumber) & (cursorx < WINDOWXSIZE)) {
	      imagesetcursor(window, cursorx, cursory);
	      if (i == cursor) {
		imagesettextcolor(window, 0xffffff, 0x03050ff);
		imagefillbox(window, cursorx, cursory-7, cursorx+(WINDOWXSIZE/3)-1, cursory, 0xffffff);
	      }
	      strcpy(filestring, fnames[fnamesptr[i]].name);
	      if (strlen(filestring) > ((WINDOWXSIZE/24)-1)) {
		filestring[(WINDOWXSIZE/24)-9] = '.';
		filestring[(WINDOWXSIZE/24)-8] = '.';
		strcpy(&filestring[(WINDOWXSIZE/24)-7], &filestring[strlen(filestring)-6]);
//		filestring[(WINDOWXSIZE/24)-2] = '.';
//		filestring[(WINDOWXSIZE/24)-1] = 0;
	      }
	      stringwrite(window, filestring);
	      if (fnames[fnamesptr[i]].attr == FA_DIREC) {	/* directory? */
		channelout(window, '\\');
	      }
	      if (i == cursor) {
		imagesettextcolor(window, 0x03050ff, 0xffffff);
	      }
	      cursory = cursory + 8;
	      if (cursory >= (MAXROWS*8) + 35) {
		cursory = 35;
		cursorx = cursorx + (WINDOWXSIZE/3);
	      }
	      i++;
	    } /* while */

	    update = 0;
	  } /* if (update) */

	  do {
	    imageupdate();
	    i = channelin(keyboard);
	    key = (unsigned char)(i & 0xff);
	    keyspec = (unsigned char) ((i >> 8) & 0xff);
	  }
	  while ((key ==0) && (!exitprogram));
	  switch (key) {
	    case 13 :
	      if (fnames[fnamesptr[cursor]].attr == -1) {
	      }
	      else {
	        if (fnames[fnamesptr[cursor]].attr == -2) {
		  imagesetcursor(window, 12, WINDOWYSIZE-25);
		  imagefillbox(window, 0, WINDOWYSIZE-32, WINDOWXSIZE, WINDOWYSIZE-25, 0x03050ff);
		  stringwritemessage(window,
"!\
ENew file name (<ESC> to cancel) >;\
GNeuer Dateiname (<ESC> = Abbruch) >;\
;");
		  strcpy(filestring, "");
		  imagestringread(window, keyboard, filestring, 26);
		  if (strlen(filestring) != 0) {
		    strcpy(filename, path);
		    if (filename[strlen(filename)-1]!='\\') {
		      strcat(filename,"\\");
		    }
		    strcat(filename, filestring);
		  }
		  else {
		    key = 0;
		    update = 1;
		  }
		}
		else {
		  if (fnames[fnamesptr[cursor]].attr == -3) {
		    imagesetcursor(window, 12, WINDOWYSIZE-25);
		    imagefillbox(window, 0, WINDOWYSIZE-32, WINDOWXSIZE, WINDOWYSIZE-25, 0x03050ff);
		    stringwritemessage(window,
"!\
EEnter drive or <ENTER> to cancel: _;\
GBitte Laufwerksbuchstaben eingeben (<ENTER> = Abbruch): _;\
;");
		    imageupdate();
		    do {
		      key = (unsigned char)channelin(keyboard);
		    }
		    while ((key == 0) && (!exitprogram));
		    if ((key >= 'a') && (key <= 'z')) {
		      setdisk(key - 'a');
		      reload = 1;
		    }
		    else {
		      if ((key >= 'A') && (key <= 'Z')) {
		        setdisk(key - 'A');
		        reload = 1;
		      }
		    }
		    key = 0;
		    update = 1;
		  }
		  else {
		    if (fnames[fnamesptr[cursor]].attr) {
		      chdir(fnames[fnamesptr[cursor]].name);
		      reload = 1;
		      update = 1;
		      key    = 0;
		    }
		    else {
		      strcpy(filename, path);
		      if (filename[strlen(filename)-1]!='\\') {
		        strcat(filename,"\\");
		      }
		      strcat(filename, fnames[fnamesptr[cursor]].name);
		    }
		  }
		}
	      }
	      break;
	    case 27 :
	    case 32 :
	      chdir(oldpath);
	      break;
	    case 28 :
	      switch (keyspec) {
		case 0x90 :		/* <Arrow-Left> */
		  if (cursor >= MAXROWS) {
		    cursor = cursor - MAXROWS;
		    if (cursor < columnstart) {
		      columnstart = columnstart - MAXROWS;
		      if (columnstart < 0) { columnstart = 0; }
		    }
		  }
		  update = 1;
		  break;
		case 0x91 :		/* <Arrow-Right> */
		  if ((cursor + MAXROWS) < filenumber) {
		    cursor = cursor + MAXROWS;
		    if (cursor >= (columnstart+3*MAXROWS)) {
		      columnstart = columnstart + MAXROWS;
		    }
		  }
		  update = 1;
		  break;
		case 0x92 :		/* <Arrow-Up> */
		  if (cursor > 0) {
		    cursor--;
		    if (cursor < columnstart) {
		      columnstart = columnstart - MAXROWS;
		      if (columnstart < 0) { columnstart = 0; }
		    }
		  }
		  update = 1;
		  break;
		case 0x93 :		/* <Arrow-Down> */
		  if (cursor < (filenumber-1)) {
		    cursor++;
		    if (cursor >= (columnstart+3*MAXROWS)) {
		      columnstart = columnstart + MAXROWS;
		    }
		  }
		  update = 1;
		  break;
	      } /* switch (keyspec) */
	  } /* switch (key) */

	}
	while ((key != 13) && (key != 27) && (key != 32) && (!exitprogram));

	channelclose(keyboard);
	channelclose(window);

	return (key == 13);
      } /* fileselectmenu */


/*-------------------------------------*/


      void aboutmenu () {
	unsigned int keyboard;
	unsigned int window;
	unsigned char key;
	unsigned int update;

	if (!windowaddio( -1, -1, WINDOWXSIZE, WINDOWYSIZE, -1, 1,
"!\
EAbout EMU][ v" DappleVersion ";\
Gber EMU][ v" DappleVersion ";\
", 0, &keyboard, &window)) {
	  update = 1;
	  do {
	    switch (update) {
	      case 1 :
		channelout(window, 12);		/* clear window */
		imagefillbox(window, 96, 43, WINDOWXSIZE-97, 43, RGBDARK);
		imagefillbox(window, WINDOWXSIZE-97, 22, WINDOWXSIZE-97, 43, RGBDARK);
		imagefillbox(window, 96, 22, WINDOWXSIZE-97, 22, RGBWHITE);
		imagefillbox(window, 96, 22, 96, 43, RGBWHITE);
		imagefillbox(window, 97, 23, WINDOWXSIZE-98, 42, 0x4070f0);
		imagesettextcolor(window, -1, RGBWHITE);
		stringwrite(window, "\r\r");
		imagesettextattribute(window, IMAGEBOLD);
		stringwritecenterx(window, "Author:");
		imagesettextattribute(window, 0);
		stringwritemessage(window,
/* I'd like to say dapple.sourceforge.net, but I can't update it right now
   since I don't have access to an "ssh" program and can't log in to the
   server any other way. -uso. */
"!\
E\
\r\r\r\r\
EMU][ v" DappleVersion" was written by Steve Nickolas\r\
with some small portions by Holger Picker.\r\r\
Please send any comments, suggestions, bug reports to\r\
<steve@dosius.zzn.com>.\r\r\
For latest updates visit the homepage at\r\
<http://sourceforge.net/projects/dapple/>.\r\
;\
G\
\r\r\r\r\
EMU][ v" DappleVersion" wurde geschrieben von Steve Nickolas\r\
unter Einbeziehung kleiner Codeteile von Holger Picker.\r\r\
Bitte schicken Sie Ihre Meinung, Vorschlge oder\r\
Fehlerberichte an:\r\
<steve@dosius.zzn.com>.\r\r\
Die neuesten Updates finden Sie auf der Homepage\r\
<http://sourceforge.net/projects/dapple/>.\r\
;\
");
		update = 2;
		break;
	      case 2 :
		channelout(window, 12);		/* clear window */
		imagefillbox(window, 96, 43, WINDOWXSIZE-97, 43, RGBDARK);
		imagefillbox(window, WINDOWXSIZE-97, 22, WINDOWXSIZE-97, 43, RGBDARK);
		imagefillbox(window, 96, 22, WINDOWXSIZE-97, 22, RGBWHITE);
		imagefillbox(window, 96, 22, 96, 43, RGBWHITE);
		imagefillbox(window, 97, 23, WINDOWXSIZE-98, 42, 0x4070f0);
		imagesettextcolor(window, -1, RGBWHITE);
		stringwrite(window, "\r\r");
		imagesettextattribute(window, IMAGEBOLD);
		stringwritecenterx(window, "Credits:");
		imagesettextattribute(window, 0);
		stringwritemessage(window,
"!\
E\r\r\r\rEMU][ was made possible with the help of a lot of people.\r\r\
Thanks to (in alphabetical order):\r\r;\
G\r\r\r\rEMU][ war nur mglich dank der Untersttzung\rund Hilfe vieler Leute.\r\r\
Dankeschn an (in alphabetischer Reihenfolge):\r\r;\
");
		stringwrite(window,"\
- Scott Alfter,\r\
- David Empson,\r\
- Andrew Gregory,\r\
- Scott Hemphill,\r\
- Robert Munafo,\r\
- Jon Relay,\r\
- Paul R. Santa-Maria,\r\
- Michael Tippach.\r\
");
		update = 3;
		break;
	      case 3 :
		channelout(window, 12);		/* clear window */
		imagefillbox(window, 96, 43, WINDOWXSIZE-97, 43, RGBDARK);
		imagefillbox(window, WINDOWXSIZE-97, 22, WINDOWXSIZE-97, 43, RGBDARK);
		imagefillbox(window, 96, 22, WINDOWXSIZE-97, 22, RGBWHITE);
		imagefillbox(window, 96, 22, 96, 43, RGBWHITE);
		imagefillbox(window, 97, 23, WINDOWXSIZE-98, 42, 0x4070f0);
		imagesettextcolor(window, -1, RGBWHITE);
		stringwrite(window, "\r\r");
		imagesettextattribute(window, IMAGEBOLD);
		stringwritecenterx(window, "Function Keys:");
		imagesettextattribute(window, 0);
		stringwritemessage(window,
"!\
E\
\r\r\r\rDuring emulation you can use the following function keys:\r\r\
<F1>       : Parallel interface options\r\
<F2>       : Mouse options\r\
<F3>       : Video options\r\
<Shift-F3> : Toggle color/monochrome mode\r\
<Ctrl-F3>  : Toggle color palette\r\
<F4>       : CPU options\r\
<Shift-F4> : Toggle CPU fast/1 MHz mode\r\
<Ctrl-F4>  : Toggle pause on/off\r\
<F5>       : Mass store device options\r\
<F6>       : Disk options\r\
<F8>       : Memory options\r\
<Shift-F8> : Quicksave emulation state\r\
<Ctrl-F8>  : Quickload emulation state\r\
<F9>       : Keyboard/joystick options\r\
<Ctrl-F9>  : Debugger\r\
<F10>      : Main menu\r\
<Ctrl-F10> : Reset\r\
<F11>      : Apple //c \"40/80\" switch\r\
<Alt-F4> will quit the emulator\r\
;\
G\
\r\r\r\rWhrend der Emulation knnen folgende Funktionstasten\rbenutzt werden:\r\r\
<F1>       : Parallelschnittstelle Optionen\r\
<F2>       : Maus Optionen\r\
<F3>       : Video Optionen\r\
<Shift-F3> : Wechsel zwischen Farb- und Monochrom-Darstellung\r\
<Ctrl-F3>  : Wechsel zwischen verschiedenen Farbpaletten\r\
<F4>       : CPU Optionen\r\
<Shift-F4> : Schalte CPU in den Schnell- oder 1 MHz-Modus\r\
<Ctrl-F4>  : Schalte Pause ein/aus\r\
<F5>       : Massenspeichergert Optionen\r\
<F6>       : Laufwerk Optionen\r\
<F8>       : Speicher Optionen\r\
<Shift-F8> : Schnellspeicherung des Emulationzustandes\r\
<Ctrl-F8>  : Schnellladen des Emulationszustandes\r\
<F9>       : Tastatur/Joystick Optionen\r\
<Ctrl-F9>  : Debugger\r\
<F10>      : Hauptmen\r\
<Ctrl-F10> : Reset\r\
<F11>      : Apple //c \"40/80\" Schalter\r\
<Alt-F4> beendet den Emulator\r\
;\
");
		update = 1;
		break;
	    } /* switch */
	    imagesetcursor(window, imagegetcursorx(window), WINDOWYSIZE-8);
	    stringwritemessage(window,
"!\
EPress <ESC> to quit, <SPACEBAR> to continue.;\
G<ESC> zurck zum Hauptmen, <SPACEBAR> zum Fortfahren.;\
");
	    do {
	      imageupdate();
	      key = (unsigned char)channelin(keyboard);
	    }
	    while ((key == 0) && (!exitprogram));
	  }
	  while ((key != 27) && (!exitprogram) && (update != 4));
	  channelclose(keyboard);
	  channelclose(window);
	}

      } /* aboutmenu */


/*-------------------------------------*/


      void mainmenu() {
	unsigned int  menukeyboard;
	unsigned int  menuwindow;
	unsigned char key;
	unsigned int  update;
	unsigned char menu;

	do {
	  if (windowaddio( -1, -1, WINDOWXSIZE, WINDOWYSIZE, -1, 1,
"!\
EEMU][ Menu;\
GEMU][ Men;\
", 0, &menukeyboard, &menuwindow)) {
	    menu = 1;
	    exitprogram = 1;
	  }
	  else {
	    menu   = 0;
	    update = 1;
	    do {
	      if (update) {
		channelout(menuwindow, 12);		/* clear window */
		imagefillbox(menuwindow, 64, 51, WINDOWXSIZE-65, 51, RGBDARK);
		imagefillbox(menuwindow, WINDOWXSIZE-65, 26, WINDOWXSIZE-65, 51, RGBDARK);
		imagefillbox(menuwindow, 64, 26, WINDOWXSIZE-65, 26, RGBWHITE);
		imagefillbox(menuwindow, 64, 26, 64, 51, RGBWHITE);
		imagefillbox(menuwindow, 65, 27, WINDOWXSIZE-66, 50, 0x4070f0);
		imagesettextcolor(menuwindow, -1, RGBWHITE);
		imagesettextattribute(menuwindow, IMAGEBOLD);
		stringwrite(menuwindow, "\r\r");
		stringwritecenterx(menuwindow, "EMU][ v" DappleVersion);
		channelout(menuwindow, 13);
		imagesetcursor(menuwindow, imagegetcursorx(menuwindow), imagegetcursory(menuwindow)+2);
		stringwritecenterx(menuwindow, "(C) 2002, 2003 EMU][ Project/Dapple ][ Team");
		channelout(menuwindow, 13);
		imagesettextattribute(menuwindow, 0);

		stringwritemessage(menuwindow,
"!\
E\r\r[ESC] - Resume emulation\r;\
G\r\r[ESC] - Emulation fortsetzen\r;\
");

		if ((slots[1].slotname) && (slots[1].slotmenu != &slotnofunction)) {
		  stringwrite(menuwindow, "\r[1] - Slot 1: ");
		  stringwritemessage(menuwindow, slots[1].slotname);
		  stringwritemessage(menuwindow,
"!\
E Options;\
G Optionen;\
");
		}
		if ((slots[2].slotname) && (slots[2].slotmenu != &slotnofunction)) {
		  stringwrite(menuwindow, "\r[2] - Slot 2: ");
		  stringwritemessage(menuwindow, slots[2].slotname);
		  stringwritemessage(menuwindow,
"!\
E Options;\
G Optionen;\
");
		}
		if ((slots[4].slotname) && (slots[4].slotmenu != &slotnofunction)) {
		  stringwrite(menuwindow, "\r[4] - Slot 4: ");
		  stringwritemessage(menuwindow, slots[4].slotname);
		  stringwritemessage(menuwindow,
"!\
E Options;\
G Optionen;\
");
		}
		if ((slots[5].slotname) && (slots[5].slotmenu != &slotnofunction)) {
		  stringwrite(menuwindow, "\r[5] - Slot 5: ");
		  stringwritemessage(menuwindow, slots[5].slotname);
		  stringwritemessage(menuwindow,
"!\
E Options;\
G Optionen;\
");
		}
		if ((slots[6].slotname) && (slots[6].slotmenu != &slotnofunction)) {
		  stringwrite(menuwindow, "\r[6] - Slot 6: ");
		  stringwritemessage(menuwindow, slots[6].slotname);
		  stringwritemessage(menuwindow,
"!\
E Options;\
G Optionen;\
");
		}
		if ((slots[7].slotname) && (slots[7].slotmenu != &slotnofunction)) {
		  stringwrite(menuwindow, "\r[7] - Slot 7: ");
		  stringwritemessage(menuwindow, slots[7].slotname);
		  stringwritemessage(menuwindow,
"!\
E Options;\
G Optionen;\
");
		}
		stringwritemessage(menuwindow,
"!\
E\r\
\r[A] - About EMU][\
\r[C] - CPU options\
\r[K] - Keyboard options\
\r[L] - Menu language: English\
\r[M] - Memory options\
\r[N] - Sound options\
\r[V] - Video options\
\r[Q] - Quit emulator\
;\
G\r\
\r[A] - Informationen ber EMU][\
\r[C] - CPU Optionen\
\r[K] - Keyboard Optionen\
\r[L] - Mensprache: Deutsch (in Bearbeitung)\
\r[M] - Speicher Optionen\
\r[N] - Sound Optionen\
\r[V] - Video Optionen\
\r[Q] - Verlasse Emulator\
;\
");
		update = 0;
	      }
	      do {
		imageupdate();
		key = (unsigned char)channelin(menukeyboard);
	      }
	      while ((key == 0) && (!exitprogram));
	      switch (key) {
		case 13 :
		case 27 :
		case 32 :
		  if (appletype == 0) {
		    stringwritemessage(menuwindow,
"!\
E\r\rSorry, no Apple roms have been loaded yet.\r;\
G\r\rBedaure, es wurden noch keine Apple Roms geladen.\r;\
");
		    windowpresskey(menukeyboard, menuwindow);
		    update = 1;
		  }
		  else {
		    menu = 1;
		  }
		  break;
		case '1' :
		  menu = 21;
		  break;
		case '2' :
		  menu = 22;
		  break;
		case '5' :
		  menu = 25;
		  break;
		case '6' :
		  menu = 26;
		  break;
		case 'a' :
		case 'A' :
		  menu = 2;
		  break;
		case 'c' :
		case 'C' :
		  menu = 3;
		  break;
		case 'd' :
		case 'D' :
		  menu = 4;
		  break;
		case 'k' :
		case 'K' :
		  menu = 5;
		  break;
		case 'l' :
		case 'L' :
		  if (inimenulanguage == 'E') {
		    inimenulanguage = 'G';
		  }
		  else {
		    inimenulanguage = 'E';
		  }
		  asmsetlanguage(inimenulanguage);
		  menu = 10;
		  break;
		case 'm' :
		case 'M' :
		  menu = 6;
		  break;
		case 'n' :
		case 'N' :
		  menu = 7;
		  break;
		case 'v' :
		case 'V' :
		  menu = 8;
		  break;
		case 'q' :
		case 'Q' :
		  menu = 9;
		  break;
	      } /* switch (key) */
	    }
	    while ((menu == 0) && (!exitprogram));
	    channelclose(menukeyboard);
	    channelclose(menuwindow);
	  }
	  switch (menu) {
	    case 2 :
	      aboutmenu();
	      break;
	    case 3 :
	      cpumenu();
	      break;
//	    case 4 :
//	      drivemenu();
//	      break;
	    case 5 :
	      keyboardmenu();
	      break;
	    case 6 :
	      memorymenu();
	      break;
	    case 7 :
	      soundmenu();
	      break;
	    case 8 :
	      virtmenu();
	      break;
	    case 9 :
	      quitmenu();
	      break;
	    case 21 :
	      slots[1].slotmenu(slots[1].slotdata);
	      break;
	    case 22 :
	      slots[2].slotmenu(slots[2].slotdata);
	      break;
	    case 25 :
	      slots[5].slotmenu(slots[5].slotdata);
	      break;
	    case 26 :
	      slots[6].slotmenu(slots[6].slotdata);
	      break;
	  } /* switch (menu) */
	} while ((menu != 1) && (!exitprogram));

      } /* mainmenu */


/*--------------------------------------*/


      int main () {
	unsigned int keyprotocol;
	unsigned int winprotocol;
	register unsigned int cpustate;

/* prevent ^C from killing us -uso. (2002.0130) */
//	signal (SIGINT, SIG_IGN); (sometimes GPFs? -uso.)
#ifndef NOGRABBREAK
	_go32_want_ctrl_break(1);
	__djgpp_set_ctrl_c(0);
#endif

/* initialize global variables */
	keyboard	= 0;
	window		= 0;
	cwdxchgslash(callingpath, 260);		/* store original directory at calling Dapple */

/* bugfix: try to reopen the printer as a binary file -uso. */
//      if (!freopen("/dev/prn","wb",stdprn)) return 0;
        _fmode=O_BINARY;


/* initialize asm library */
	if (asmopen()) {
	  goto endofprogram2;
	}

/* set resolution */
	if (screensetresolution(640,400,8)) {
	  if (screensetresolution(640,480,8)) {
	    if (screensetresolution(800,600,8)) {
	      if (screensetresolution(1024,768,8)) {
 		printf ("No suitable video modes found (no VESA?).\n");
		goto endofprogram2;
	      }
	    }
	  }
	}

/* open emulation window */
	if (windowaddio( -1, -1, 640, 400, 0, 0, NULL, 1, &keyboard, &window)) { goto endofprogram2; }
	imagefillbox(window, 0, 0, 640, 400, 0x000000);

	if (windowaddio( -1, -1, 544, 304, -1, 1, "Protocol", 0, &keyprotocol, &winprotocol)) { goto endofprogram; }

	stringwrite(winprotocol, "Welcome to EMU][ v" DappleVersion "\r");
	stringwrite(winprotocol, "=========================\r\r");
	stringwrite(winprotocol, "This version features emulation of up to 3MB\r");
	stringwrite(winprotocol, "expansion RAM dynamically allocated.\r");
	imageupdate();
	messagecount = 0;
	messageflag = 0;

/* initialize default values */

	strcpy(inidiskpath1, "");
	strcpy(inidiskpath2, "");
	strcpy(inistatepath, "EMU2.SAV");
	strcpy(inirompath,   callingpath);
	strcat(inirompath,   "\\ROMS");
	inimenulanguage	= 'E';		/* set language to English */
	inicpudelay	= 0x120;
	inidebugflag	= 0;

	slotempty(&slots[0]);	/* not really in use, is it? */
	slotempty(&slots[1]);
	slotempty(&slots[2]);
	slotempty(&slots[3]);
	slotempty(&slots[4]);
	slotempty(&slots[5]);
	slotempty(&slots[6]);
	slotempty(&slots[7]);

/* initialize emulator */

	cpuinit();
#ifdef EMUZ80
	z80init();
#endif
	memoryinit();
	keyboardinit();
	soundinit();
	virtinit();
	parallelinit();
	mouseinit();
	driveinit();
	lldiskinit();

/* get default values from file */

	readini();
	asmsetlanguage(inimenulanguage);

/* automatic search for rom file */

	memoryautoloadrom(keyprotocol, winprotocol);

#ifdef EMUZ80
	z80loadrom     (keyprotocol, winprotocol);
#endif
	parallelloadrom(keyprotocol, winprotocol);
	mouseloadrom   (keyprotocol, winprotocol);
	driveloadrom   (keyprotocol, winprotocol);
	lldiskloadrom  (keyprotocol, winprotocol);

	if (parallelnew(&slots[1], 1)) {
	  slotempty(&slots[1]);
	}
	if (mousenew(&slots[2], 2)) {
	  slotempty(&slots[2]);
	}
#ifdef EMUZ80
	if (z80new(&slots[4], 4)) {
	  slotempty(&slots[4]);
	}
#endif
	if (lldisknew(&slots[5], 5)) {
	  slotempty(&slots[5]);
	}
	if (drivenew(&slots[6], 6)) {
	  slotempty(&slots[6]);
	}

	if (inidiskpath1[0]) {
	  driveload(&drivedisk1, inidiskpath1);
	}
	if (inidiskpath2[0]) {
	  driveload(&drivedisk2, inidiskpath2);
	}
/*	windowpresskey(keyprotocol, winprotocol); */
	channelclose(keyprotocol);
	channelclose(winprotocol);

	imagefillbox(window, 40, 8, 559 + 40, 391, 0x000000);
	messageflag = 1;	/* allow messages */
	setmessage(
"!\
EWelcome to EMU][;\
GWillkommen bei EMU][;\
");
	cpusetdelay(inicpudelay);
	mainmenu();
	if (!exitprogram) {
	  applereset();
	  do {
	    if (!cpuflag) {
	      cpuline();	/* cpu, video, mouse emulation */
	      cpustate = cpugetstate();
	      if (cpustate & (STATETRACE | STATEGURU | STATEBPT /*| STATEBRK */)) {
		cpumenu();
		imageupdate();
		if (cpustate & STATETRACE)	{ cpuclearstate(STATETRACE); }
		if (cpustate & STATEGURU)	{ cpuclearstate(STATEGURU); }
	      }
	    }
#ifdef EMUZ80
	    else {
	      z80line();
	      cpustate = z80getstate();
	      if (cpustate & (STATETRACE | STATEGURU | STATEBPT)) {
		cpumenu();
		imageupdate();
		if (cpustate & STATETRACE)	{ z80clearstate(STATETRACE); }
		if (cpustate & STATEGURU)	{ z80clearstate(STATEGURU); }
	      }
	    }
#endif

	    if (cpuwriteregsflag) {
	      imagesettextcolor(window, RGBBLACK, RGBWHITE);
	      imagesetcursor(window, 0, 7);
#ifdef EMUZ80
	      if (!cpuflag) {
#endif
		cpuwriteregs(window);
#ifdef EMUZ80
	      }
	      else {
		z80writeregs(window);
	      }
#endif
	      virtcopy = 1;
	    }

	    if (messagecount != 0) {
	      messagecount--;
	      if (messagecount == 0) {
		imagefillbox(window, 0, 392, 639, 399, 0x000000);
		virtcopy = 1;
	      }
	    }
	    virtscreencopy();
	    keyconvert();
	  }
	  while (!exitprogram);
	} /* if (!exitprogram) */

	memoryclose();				/* free dynamically allocated memory */
	exitprogram = 0;

	slots[1].slotclose(slots[1].slotdata);
	slots[2].slotclose(slots[2].slotdata);
	slots[3].slotclose(slots[3].slotdata);
	slots[4].slotclose(slots[4].slotdata);
	slots[5].slotclose(slots[5].slotdata);
	slots[6].slotclose(slots[6].slotdata);
	slots[7].slotclose(slots[7].slotdata);

	chdir(callingpath);			/* restore original directory at calling Dapple */
	writeini();

endofprogram:
	channelclose(window);
	channelclose(keyboard);

endofprogram2:
	asmclose();

	return 0;

      } /* main */
