@echo off
:: Make script for EMU][

nasm -f coff -o cpu.o cpu6502.asm

:cpu65c02
:: cpu65c02 dependencies: cpu65c02.c, dapple.h, asmlib.h
newer cpu65c02.o cpu65c02.c
if errorlevel 1 goto b_cpu65c02
newer cpu65c02.o dapple.h
if errorlevel 1 goto b_cpu65c02
newer cpu65c02.o asmlib.h
if errorlevel 1 goto b_cpu65c02
goto dapple
:b_cpu65c02
ECHO Compiling cpu65c02.c ...
redir -o cpu65c02.err -eo gcc -Wall -O3 -fomit-frame-pointer -s -c cpu65c02.c
if errorlevel 1 goto gccerr

:dapple
:: dapple dependencies: dapple.c, dapple.h, asmlib.h
newer dapple.o dapple.c
if errorlevel 1 goto b_dapple
newer dapple.o dapple.h
if errorlevel 1 goto b_dapple
newer dapple.o asmlib.h
if errorlevel 1 goto b_dapple
newer dapple.o version.h
if errorlevel 1 goto b_dapple
goto disk
:b_dapple
ECHO Compiling dapple.c ...
redir -o dapple.err -eo gcc -Wall -O3 -fomit-frame-pointer -s -c dapple.c
if errorlevel 1 goto gccerr

:disk
:: disk dependencies: disk.c, dapple.h, asmlib.h
newer disk.o disk.c
if errorlevel 1 goto b_disk
newer disk.o dapple.h
if errorlevel 1 goto b_disk
newer disk.o asmlib.h
if errorlevel 1 goto b_disk
goto ini
:b_disk
ECHO Compiling disk.c ...
redir -o disk.err -eo gcc -Wall -O3 -fomit-frame-pointer -s -c disk.c
if errorlevel 1 goto gccerr

:ini
:: ini dependencies: ini.c, dapple.h
newer ini.o ini.c
if errorlevel 1 goto b_ini
newer ini.o dapple.h
if errorlevel 1 goto b_ini
goto lldisk
:b_ini
ECHO Compiling ini.c ...
redir -o ini.err -eo gcc -Wall -O3 -fomit-frame-pointer -s -c ini.c
if errorlevel 1 goto gccerr

:lldisk
:: lldisk dependencies: lldisk.c, dapple.h, asmlib.h
newer lldisk.o lldisk.c
if errorlevel 1 goto b_lldisk
newer lldisk.o dapple.h
if errorlevel 1 goto b_lldisk
newer lldisk.o asmlib.h
if errorlevel 1 goto b_lldisk
goto memory
:b_lldisk
ECHO Compiling lldisk.c ...
redir -o lldisk.err -eo gcc -Wall -O3 -fomit-frame-pointer -s -c lldisk.c
if errorlevel 1 goto gccerr

:memory
:: memory dependencies: lldisk.c, dapple.h, asmlib.h
newer memory.o memory.c
if errorlevel 1 goto b_memory
newer memory.o dapple.h
if errorlevel 1 goto b_memory
newer memory.o asmlib.h
if errorlevel 1 goto b_memory
goto mouse
:b_memory
ECHO Compiling memory.c ...
redir -o memory.err -eo gcc -Wall -O3 -fomit-frame-pointer -s -c memory.c
if errorlevel 1 goto gccerr

:mouse
:: mouse dependencies: mouse.c, dapple.h, asmlib.h
newer mouse.o mouse.c
if errorlevel 1 goto b_mouse
newer mouse.o dapple.h
if errorlevel 1 goto b_mouse
newer mouse.o asmlib.h
if errorlevel 1 goto b_mouse
goto pic
:b_mouse
ECHO Compiling mouse.c ...
redir -o mouse.err -eo gcc -Wall -O3 -fomit-frame-pointer -s -c mouse.c
if errorlevel 1 goto gccerr

:pic
:: pic dependencies: pic.c, asmlib.h
newer pic.o pic.c
if errorlevel 1 goto b_pic
newer pic.o asmlib.h
if errorlevel 1 goto b_pic
goto rom
:b_pic
ECHO Compiling pic.c ...
redir -o pic.err -eo gcc -Wall -O3 -fomit-frame-pointer -s -c pic.c
if errorlevel 1 goto gccerr

:rom
:: DISABLED
:: :: rom dependencies: rom.c, dapple.h, asmlib.h
:: newer rom.o rom.c
:: if errorlevel 1 goto b_rom
:: newer rom.o dapple.h
:: if errorlevel 1 goto b_rom
:: newer rom.o asmlib.h
:: if errorlevel 1 goto b_rom
:: newer rom.o version.h
:: if errorlevel 1 goto b_rom
:: goto video
:: :b_rom
:: ECHO Compiling rom.c ...
:: redir -o rom.err -eo gcc -Wall -O3 -fomit-frame-pointer -s -c rom.c
:: if errorlevel 1 goto gccerr

:video
:: video dependencies: video.c, dapple.h, asmlib.h
newer video.o video.c
if errorlevel 1 goto b_video
newer video.o dapple.h
if errorlevel 1 goto b_video
newer video.o asmlib.h
if errorlevel 1 goto b_video
newer video.o font.h
if errorlevel 1 goto b_video
goto linktop
:b_video
ECHO Compiling video.c ...
redir -o video.err -eo gcc -Wall -O3 -fomit-frame-pointer -s -c video.c
if errorlevel 1 goto gccerr

:linktop
:: emuii.exe dependencies
newer emuii.exe asmlib.o
if errorlevel 1 goto golink
newer emuii.exe cpu65c02.o
if errorlevel 1 goto golink
newer emuii.exe dapple.o
if errorlevel 1 goto golink
newer emuii.exe disk.o
if errorlevel 1 goto golink
newer emuii.exe ini.o
if errorlevel 1 goto golink
newer emuii.exe lldisk.o
if errorlevel 1 goto golink
newer emuii.exe memory.o
if errorlevel 1 goto golink
newer emuii.exe mouse.o
if errorlevel 1 goto golink
newer emuii.exe pic.o
if errorlevel 1 goto golink
newer emuii.exe rom.o
if errorlevel 1 goto golink
newer emuii.exe video.o
if errorlevel 1 goto golink

:: And in case we change the make script...

newer emuii.exe mk.bat
if errorlevel 1 goto golink

echo (Your binaries are already up-to-date.)
goto absend

:golink
:: 127-char limit -uso.
ECHO Linking emuii.exe ...
redir -o link.err -eo gcc @dapple2.ls
if errorlevel 1 goto linkerr

REM Not needed; the -s switch to gcc impedes writing the symbols in the
REM first place. -uso.
REM ECHO Strip symbols from .EXE
REM STRIP.EXE -s --strip-all emuii.exe

REM _Probably_ not really needed anymore. Just here to compress the file
:: ECHO Add DOS-Extender...
:: Change the directory to reflect the location of your stubit.exe file
:: STUBIT.EXE emuii.exe
:: del dapple2.bak
call restub
GOTO end

:gccerr
ECHO Error in C file
GOTO end

:linkerr
ECHO Link error

:end
prtwhead *.err>error.log
del *.err

:absend
